/**
*	jQuery File Tree functions for FlashAir
*	Version 1.0
*	jijy.tadano@gmail.com
*	14 Mar 2015
*/
// Callback Function for sort()
function cmptime(a, b) {
    if( a["fdate"] == b["fdate"] ) {
        return a["ftime"] - b["ftime"];
    }else{
        return a["fdate"] - b["fdate"];
    }
}
// Making Path (allow japanese dir names)
function makePath(dir) {
	var arrPath = dir.split('/');
	if ( dir != '/' ) {
		arrPath.pop();
		for (var i = 0; i < arrPath.length; i++) {
			if (/%[Uu]([0-9A-Fa-f]{4})/.test(arrPath[i])) {
				arrPath[i] = unescape(arrPath[i]);
			}
		}
	}
	return arrPath.join('/');
}
// Making Parent Path
function ParentDir(dir) {
	var arrDir = dir.split('/');
	for (var i = 0; i < arrDir.length; i++) {
		if (/%[Uu]([0-9A-Fa-f]{4})/.test(arrDir[i])) {
			arrDir[i] = unescape(arrDir[i]);
		}
	}
	arrDir.splice(arrDir.length-2,1);
	return arrDir.join('/');
}
// Get file list
function getDirList(currentPath,data) {
	var r = '<ul class="jqueryFileTree" style="display: none;">';
	flist0 = new Array();
	flist1 = new Array();
	elements = new Array();
	// Split lines by new line characters.
	flist0 = data.split(/\n/g);
	// Ignore the first line (title) and last line (blank).
	flist0.shift();
	flist0.pop();
	// Convert to V2 format(allow names including commas)
	for (var i = 0; i < flist0.length; i++) {
		elements = flist0[i].split(",");
		elength = elements.length;
		flist1[i] = new Array();
		flist1[i]["r_uri"] = elements[0];
		flist1[i]["fname"] = elements[1];
		if (elength > 6) {
			for (var j = 2; j <= elength-5; j++) {
				flist1[i]["fname"] = flist1[i]["fname"]+","+elements[j];
			}
		}
		flist1[i]["fsize"] = Number(elements[elength-4]);
		flist1[i]["attr"]  = Number(elements[elength-3]);
		flist1[i]["fdate"] = Number(elements[elength-2]);
		flist1[i]["ftime"] = Number(elements[elength-1]);
	}
	// Sort by date and time.
	flist1.sort(cmptime);
	// Cnvert file info for file tree
	for (var i = 0; i < flist0.length; i++) {
		var fn0 = flist1[i]['fname'];
		var ff0 = currentPath + '/' + fn0;
		if (currentPath == '/') ff0 = '/' + fn0;
		if (flist1[i]['attr'] & 0x10) { 
			r += '<li class="directory collapsed"><a href="javascript:void(0)" rel="' + ff0  + '/">' + fn0 + '</a></li>';
		} else {
			var ext = fn0.split('.')[fn0.split('.').length-1];
			r += '<li class="file ext_' + ext + '"><a href="' + ff0 + '" rel='+ ff0 + '>' + fn0 + '</a></li>';
		}
	}
	r += '</ul>';
	return r;
}
// UploadProcess
function doUpload() {
	var path = makePath($('#NowDir').val());
	var cgi = "/upload.cgi";
	var timestring;
	var dt = new Date();
	var year = (dt.getFullYear() - 1980) << 9;
	var month = (dt.getMonth() + 1) << 5;
	var date = dt.getDate();
	var hours = dt.getHours() << 11;
	var minites = dt.getMinutes() << 5;
	var seconds = Math.floor(dt.getSeconds() / 2);
	var upfle = $('#file')[0].files[0];
	timestring = "0x" + (year + month + date).toString(16) + (hours + minites + seconds).toString(16);	
	$.get(cgi + "?WRITEPROTECT=ON&UPDIR=" + path + "&FTIME=" + timestring, function() {
		var uploadFile = $('#file')[0].files[0];
		var fd = new FormData();
		fd.append("file", uploadFile);
		$.ajax({ url: cgi,
			type: "POST",
			data: fd,
			processData: false,
			contentType: false,
			success: function(html){
				if ( html.indexOf("SUCCESS") ) {
					alert("success");
					location.reload();
				}else{
					alert("error");
				}
			}
		});		
	});	
	return false;
}
// DeleteProcess
function doDelete(file) {
	var cgi = "/upload.cgi?DEL=";
	ret = confirm(file+"を削除しますか？");
	if (ret == true){
		$.get(cgi + file, function(data) {
			if ( data == "SUCCESS" ) {
				alert("success");
				location.reload();
			}else{
				alert("error");
			}
		});
	}
}
